#Jan 8'19 - adjusted to be used for extended _ab
#           done: choice_placeholder has to be replaced with the actual choice... but how?? the meta prog doesnt have it... have prog_dom_abs write it to a file and read it from there
#           done: also the ap/bl atoms shoul contain the variables of the body so that the choice can be used
#           e.g.,
#           {go(X,Y,X1,Y1,T, D) : conn(X,Y,X1,Y1),row(X1), column(Y1), dir(D)}1 :- ap(r65,X,Y,T), not ko(r65).
#           ap(r65,X,Y,T) :- rAt(X,Y,T),timea(T).
#           bl(r65,X,Y,T) :- not ap(r65,X,Y,T),row(X),column(Y),time(T).
#           fixed - the issue was absprog creator : how come it is printing row/column facts two times with 0..4 range and 0..7 range?
#           done: putting arguments of the head to "ap", but what if head=falsum? -- need to put the arguments from the body???
#           done: need to update the domain program with the missing time() predicates -- right now this script puts NONE() for the respective variables
#           done: need to add weak constraints for ab_activated/deactivated
#           done: treated when ab_activated occurs for a pred as we dont look at rules for that anymore...
#           FIXME: below is happening right now - redundant rule
#              falsum :- ap(r23), not ko(r23).
#              ap(r23) :- not reachedGoal.
#              ap(r23) :- ap(r23).
#              bl(r23) :- not ap(r23).
#              :- falsum.
#Jan 17   - handles -1, -DX now
#Jan 21   - creates hint atoms according to the dom elemets that show up in ab atoms

import re
import pexpect
import time
import sys
import csv
import string
import os

class meta:
	def __init__(self,textOrg):
		self.rules=re.findall(r"rule\((\S+)\).",textOrg)
		self.head=re.findall(r"head\((\S+),\ *(\S+)\).",textOrg)
		self.negbody=re.findall(r"negbody\((\S+),\ *(\S+)\).",textOrg)
		self.posbody=re.findall(r"posbody\((\S+),\ *(\S+)\).",textOrg)
		self.pred=re.findall(r"pred\((\S+),\ *(\S+)\).",textOrg)
		self.struct=re.findall(r"struct\((\S+),\ *(\d+),\ *(\S+),\ *(\S+)\).",textOrg)
		self.arity=re.findall(r"arity\((\S+),\ *(\d+)\).",textOrg)
		self.apAtoms=[]
		self.blAtoms=[]
		self.atoms=[]
		self.predList=[]
		self.facts=[]
		self.factPreds=[]
		
	def initializeAtoms(self):
		self.getFacts()
		for r in self.rules:
			h = m.getHead(r)[0]
			#FIXME putting arguments of the head to "ap", but what if head=falsum?
			textAp="ap("+r+","
			#if h!=[] and self.getPosbody(r)==[] and self.getNegbody(r)==[]:
                
			if h!=[] and self.getArity(self.getPredName(h)[0])>0:
				for arg in self.getArgs(h):
					if re.search('v[A-Z]', arg)!=None:
						arg=arg.replace("v","")
					if arg=="TPLUS1":
						arg="T+1"
					elif arg=="TMINUS1":
						arg="T-1"
					elif "MINUS" in arg:
						arg=arg.replace('MINUS','-')
					textAp=textAp+arg+","
				textAp=textAp[:len(textAp)-1]+")"
				self.apAtoms.append([r,textAp])
				textBl=textAp.replace("ap","bl")
				self.blAtoms.append([r,textBl])
			elif self.getPosbody(r)!=[] or self.getNegbody(r)!=[]:
				posb=self.getPosbody(r)
				if posb!=[]:
					collectargs=[]
					for p in posb:
						argp=self.getArgs(p)
						#fixed below- Feb 5'19 - when the input has only objnames then below can not get the arguments!!!
						if len(argp)==1 and argp[0].replace("v","") not in collectargs:
							arg=argp[0]
							if arg=="TPLUS1":
								arg="T+1"
							elif arg=="TMINUS1":
								arg="T-1"
							elif "MINUS" in arg:
								arg=arg.replace('MINUS','-')
							collectargs.append(arg.replace("v",""))
							textAp=textAp+arg.replace("v","")+","
				#			print textAp
				#			print collectargs
						elif h==[] and obj==True and objname==m.getPredName(p)[0]:
							for z in argp:								
								collectargs.append(z.replace("v",""))
								textAp=textAp+z.replace("v","")+","
				textAp=textAp[:len(textAp)-1]+")"
				self.apAtoms.append([r,textAp])
				textBl="bl("+r+")"
				self.blAtoms.append([r,textBl])
			elif "choiceplaceholder" in self.getPredName(h)[0]:
				self.apAtoms.append([r,"ap("+r+")"])
				self.blAtoms.append([r,""])
		for pr in self.pred:
			if pr[1]=="equ" or pr[1]=="neq" or pr[1]=="less"  or pr[1]=="geq" or pr[1]=="greater" or pr[1]=="leq":
				var1=""
				var2=""
			elif "choiceplaceholder" in pr[1]:
				fin=open("aux_choice_placeholders.txt","r")
				auxplaceholders=fin.read()
				fin.close()
				choice=re.findall(pr[1]+" = (.*)",auxplaceholders)[0]
				textAtom=choice
			elif "choice_" in pr[1]:
				textAtom="{"+pr[1].replace("choice_","")
				textAtom=textAtom.replace('MINUS','-')
			elif "MINUS" in pr[1]:
				textAtom=pr[1].replace('MINUS','-')
			else:
				textAtom=pr[1]
            
			argtemp=m.getArgs(pr[0])
			if argtemp!=[]:
				textAtom+="("
				index=1
				for ii in range(0,len(argtemp)):
					arg=argtemp[ii]			
					if re.search('v[A-Z]', arg)!=None:
						arg=arg.replace("v","")
					#FIXME this is to deal with replaced time variables - make it better 
					if arg=="TPLUS1":
						arg="T+1"
					elif arg=="TMINUS1":
						arg="T-1"
					elif "MINUS" in arg:
						arg=arg.replace('MINUS','-')
					if  pr[1]=="equ" or pr[1]=="neq" or pr[1]=="less" or pr[1]=="greater" or pr[1]=="geq" or pr[1]=="leq":
						if var1=="":
							var1=arg
						else:
							var2=arg
							if pr[1]=="equ":
								textAtom=var1+"="+var2
							elif pr[1]=="neq":
								textAtom=var1+"!="+var2
							elif pr[1]=="less":
								textAtom=var1+"<"+var2
							elif pr[1]=="greater":
								textAtom=var1+">"+var2
							elif pr[1]=="geq":
								textAtom=var1+">="+var2
							elif pr[1]=="leq":
								textAtom=var1+"<="+var2
					else:
						textAtom=textAtom+arg+","
						
			#for arg in m.getArgs(pr[0]):
			#	if re.search('v[A-Z]', arg)!=None:
			#		arg=arg.replace("v","")
			#	textAtom=textAtom+arg+","
				if pr[1]!="equ" and pr[1]!="neq" and pr[1]!="less" and pr[1]!="geq" and pr[1]!="greater" and pr[1]!="leq":# and "plus" not in pr[1]:
						textAtom=textAtom[:len(textAtom)-1]+")"	
			if "choice_" in pr[1]:
				textAtom+="}"
			self.atoms.append([pr[0],textAtom])
		for ar in self.arity:
			self.predList.append(ar[0])

	def printout(self):
		#print self.changedRules
		#print self.omittedPreds
		#print self.rules
		#print self.head
		#print self.negbody
		#print self.posbody
		#print self.pred
		#print self.struct
		#print self.arity
		print "initialized"
		print self.apAtoms
		print self.blAtoms
		print self.atoms
	
	def getPred(self,p): 
		return [a[1] for a in self.pred if a[0]==p][0]
	def getHead(self,r):
		head=[a[1] for a in self.head if a[0]==r] 
		if head!=[]:
			return head
		else:
			return [[]]
	def getPosbody(self,r):
		return [a[1] for a in self.posbody if a[0]==r] 
	def getNegbody(self,r):
		return [a[1] for a in self.negbody if a[0]==r] 
	def getArity(self,p):
		return int([a[1] for a in self.arity if a[0]==p][0])
	def getArgs(self,p):
		return [a[3] for a in self.struct if a[0]==p] 
	def getType(self,p):
		return [a[2] for a in self.struct if a[0]==p] 
	def getPredSym(self,p):
		return [a[0] for a in self.pred if a[1]==p]
	def getPredName(self,p):
		return [a[1] for a in self.pred if a[0]==p]
	
	
	def getAtom(self,r):
		return [a[1] for a in self.atoms if a[0]==r]
    
	def getFacts(self):
		for a in self.rules:
			if self.getPosbody(a)==[] and self.getNegbody(a)==[]:
				self.facts.append(a)
				#FIXME for now assuming head has one atom!
				self.factPreds.append(self.getHead(a)[0])   
		
		
	def getPredOfArg(self,r,arg):
		posbody=self.getPosbody(r)
		for p in posbody:
			temp=[k[3] for k in self.struct if k[0]==p]
			if [arg]==temp or ["v"+arg]==temp:
				ppred=self.getPred(p)
				return ppred
		return "NONE"

	def fixNonesWithObjName(self,r,text,head):
		posbody=self.getPosbody(r)
		for p in posbody:
			atom=self.getAtom(p)[0]
			if objname in atom:
				args=atom[atom.index("(")+1:atom.index(")")]
				if args in head:
					text=text.replace("NONE("+args.split(",")[0]+"),NONE("+args.split(",")[1]+")",atom)
					text=text.replace("isCluster("+args.split(",")[0]+"),NONE("+args.split(",")[1]+")",atom)
					text=text.replace("NONE("+args.split(",")[0]+"),isCluster("+args.split(",")[1]+")",atom)
		return text
    

def buildMainRules(m,outtext):
 	for r in m.rules:
		#FIXME for now assuming head has one atom!
		h = m.getHead(r)[0]
		if h in m.factPreds:
			outtext+=m.getAtom(h)[0]+".\n"
			continue
		if h!=[]:
			head1=m.getAtom(h)[0]
			text4=""
		else:
			head1="falsum"
			text4=":- falsum.\n"
		apatom=m.apAtoms[m.rules.index(r)][1]
		if h!=[] and "choiceplaceholder" in m.getPredName(h)[0]:
			getheadargs=re.findall(r"\S+\(([A-Za-z0-9,]+)\)",head1)
			for gindex in range(0,len(getheadargs)):
				g=getheadargs[gindex]
				g=g.split(",")
				for a in g:
					if ",".join(getheadargs[:gindex]+getheadargs[gindex+1:]).split(",").count(a)==0 and a not in apatom:    
						apatom=apatom.replace(")",","+a+")")   
		body1=apatom+", not ko("+r+").\n"
		text1=head1+" :- "+body1
		print text1
		outtext=outtext+text1
		head2=apatom
                              
		posbodytemp = m.getPosbody(r)
		body2pos=[]
		if posbodytemp!=[]:
			for item in posbodytemp:
				bodyatom=m.getAtom(item)[0]
				if obj==True and "isCluster" in bodyatom:
					bodyatom=bodyatom.replace("isCluster","isIncCluster")
				body2pos.append(bodyatom)
		body2pos=','.join(body2pos)	
		negbodytemp = m.getNegbody(r)
		body2neg=[]
		if negbodytemp!=[]:
			for item in negbodytemp:
				body2neg.append("not "+m.getAtom(item)[0])
		body2neg=','.join(body2neg)
		text2=head2+" :- "+body2pos
		if body2pos!="" and body2neg!="":
			text2=text2+", "
		text2=text2+body2neg+".\n"
		print text2
		outtext=outtext+text2
		if h==[] or m.getArity(m.getPredName(h)[0])==0:
			outtext=outtext+"ap("+r+") :- "+head2+".\n"
			text3="bl("+r+") :- not ap("+r+").\n"
		else:
			text3=m.blAtoms[m.rules.index(r)][1]+" :- not "+head2
			#FIXME assuming ground vars dont have uppercase		
			text3a=[]
			if re.search('[A-Z]',head2)!=None:
				variables=re.findall(r"([A-Z]+[0-9]*)",head2)
				text3=text3+","
				for var in variables:
					dompred=m.getPredOfArg(r,var)
					text3a.append(dompred+"("+var+")")
			text3=text3+",".join(text3a)+".\n"
			if obj==True:
				text3=m.fixNonesWithObjName(r,text3,head2)                
		text3a=[]	
		print text3
		outtext=outtext+text3
		outtext=outtext+text4
	print "-----------------------------"
	return outtext
	#TODO constraints with falsum!	

#def createRefineHintRule(atom,collect):
    #absvars=re.findall(r'[\(,]+([A-Z]+\d*)',atom)
    #print atom
    #print absvars
    #if absvars==[]:
        #return ""
    #else:
        #text=""
##        textrefinecount="refineCount(AA,BB,S) :- refine(AA,BB), S=#count{"
        #for a in absvars:
            #text+="refine(A) :- "+atom+", mapTo(_,"+a+",A), isCluster(A).\n"
##            if absvars.index(a)>0:
##                textrefinecount+=" ; "
            #collect.append(a+" : "+atom+", mapTo(_,"+a+",AA)")
##        textrefinecount+="}.\n"    
        #return text
    
    
#def createAvoidSingletonRule(atom,collect):
    #absvars=re.findall(r'[\(,]+(X\d*),(Y\d*)',atom)
    #if absvars==[]:
        #return ""
    #else:
        #text=[]
        #for a in absvars:
            #text.append("mapTo(_,"+a[0]+","+a[1]+",A"+a[0]+",A"+a[1]+"), isSingleton(A"+a[0]+"), isSingleton(A"+a[1]+")")
        #return ",".join(text)
    
    
		#ab_deactivated(r36) ab_deactivated(r35) ab_deactivated(r34) ab_deactivated(r33) ab_deactivated(r32) ab_deactivated(r30) ab_deactivated(r28) ab_deactivated(r27) ab_deactivated(r26) ab_deactivated(r25) ab_deactivated(r21) ab_deactivated(r19) ab_deactivated(r18) ab_deactivated(r6) ab_deactivated(r5) 
		
def buildAbPRules(m,outtext,deactivatingrules):
    print deactivatingrules
    showatoms=[]
    refinehinttext=""
    collectrefinecountrules=[]
    for r in m.rules:
        h = m.getHead(r)[0]
        if deactivatingrules!=0 and r not in deactivatingrules and h!=[]:
            continue
        #FIXME for now assuming head has one atom!
        if m.getAtom(h)==[]:
            text1="{ko("+r+")}.\n"
            ap=m.apAtoms[m.rules.index(r)][1]
            abphead="ab_deactivatedConstraint("+ap[ap.find("(")+1:ap.find(")")]+")"
            #refinehinttext+=createRefineHintRule(abphead,collectrefinecountrules)
            #avoidsingletontext=createAvoidSingletonRule(abphead,collectrefinecountrules)
            text2=abphead+" :- ko("+r+"), "+ap+".\n"
            if "#show ab_deactivatedConstraint/"+str(ap.count(",")+1)+"." not in showatoms:
                showatoms.append("#show ab_deactivatedConstraint/"+str(ap.count(",")+1)+".")
            #FIXME Feb 8'19 : added also the vars to the cost of weak constraint, but may not be good   
            #       Feb 8'19 : if only some rules are deactivated, also add constraints as possibilities but with more cost 
            #                   (unless the constraint is in the list of rules to be deactivated)
            if deactivatingrules!=0:
                if "(" in ap:
                    variables=re.findall(r"([A-Z]+[0-9]*)",ap[ap.find("(")::])
                else:
                    variables=[]   
                weakvar="" 
                for var in variables:
                    weakvar+=","+var
                if r in deactivatingrules:
                    weakcon=":~ "+abphead+". [1"+weakvar+","+r+"]\n"
                else:
                    weakcon=":~ "+abphead+". [10"+weakvar+","+r+"]\n"
            else: 
                weakvar=""   
                weakcon=":~ "+abphead+". [1"+weakvar+","+r+"]\n"              
            #weakcon=":~ "+abphead+". [1,"+r+"]\n"
            
            #if avoidsingletontext!="":
                ##weakcon+=":~ "+abphead+","+avoidsingletontext+". [20,"+r+"]\n"
                #weakcon+=":~ "+abphead+","+avoidsingletontext+". [20"+weakvar+","+r+"]\n"
            outtext=outtext+text1+text2+weakcon
            print text1+text2+weakcon
        elif h in m.factPreds or "choice" in m.getAtom(h)[0] or "{" in m.getAtom(h)[0]:
            continue
        else:
            text1="ko("+r+").\n"
            head=m.getAtom(h)[0]
            ap=m.apAtoms[m.rules.index(r)][1]
            text2="{"+head+"} :- "+ap+".\n"
            if "(" in head:
                variables=re.findall(r"([A-Z]+[0-9]*)",head[head.find("(")::])
            else:
                variables=[]
            abphead="ab_deactivated("+r
            weakvar=""
            #Jan 9 - if either no entry is given or the rule is desired to be deactivated
            #if deactivatingrules==0 or r in deactivatingrules:
            if "#show ab_deactivated/"+str(len(variables)+1)+"." not in showatoms:
                showatoms.append("#show ab_deactivated/"+str(len(variables)+1)+".")
            for var in variables:
                abphead=abphead+","+var
                weakvar+=","+var
	    if deactivatingrules==0:
            	weakcons=":~ "+abphead+"). "+"[1"+weakvar+","+r+"]\n"    
	    else:
            	weakcons=":~ "+abphead+"). "+"[1"+weakvar+","+r+"]\n"  		        
            #refinehinttext+=createRefineHintRule(abphead+")",collectrefinecountrules) 
            #avoidsingletontext=createAvoidSingletonRule(abphead+")",collectrefinecountrules)
            #if avoidsingletontext!="":
                #weakcons+=":~ "+abphead+"),"+avoidsingletontext+". [20"+weakvar+","+r+"]\n"
            #Jan 9 - if there is an entry and rule is not desired to be deactivated then no further ab atoms are added for this rule
            #else:
            #    #weakcons=":~ "+abphead+"). "+"[10"+weakvar+","+r+"]\n"   
            #    continue
            abphead=abphead+") :- "
            text3=abphead+ap+", not "+head+".\n"
            print text1+text2+text3+weakcons
            outtext=outtext+text1+text2+text3+weakcons
    #if collectrefinecountrules!=[]:
        #textrefinecount="\nrefineCountAbP(AA,S) :- refine(AA), S=#count{"+" ; ".join(collectrefinecountrules)+"}.\n#show refineCountAbP/2.\n"
    #else:
    textrefinecount=""
                
    return outtext+"\n".join(showatoms)+"\n"#+refinehinttext+"#show refine/2."+textrefinecount
	
		#ab_activated(r6) ab_activated(r5) ab_activated(r21) ab_activated(r18) ab_activated(r40) ab_activated(r39) ab_activated(r38) ab_activated(r37) ab_activated(r36) ab_activated(r35) ab_activated(r34) ab_activated(r33) ab_activated(r32) ab_activated(r31) ab_activated(r30) ab_activated(r29) ab_activated(r28) ab_activated(r27) ab_activated(r26) ab_activated(r25) ab_activated(r19) 
		
def buildAbCRules(m,outtext,activatingpreds):
	'''showatoms=[]
	
	for r in m.rules:
		#FIXME for now assuming head has one atom!
		h = m.getHead(r)[0]
		if h in m.factPreds or m.getAtom(h)==[] or "choice_" in m.getAtom(h)[0] or "{" in m.getAtom(h)[0]:
			continue
		head=m.getAtom(h)[0]
		bl=m.blAtoms[m.rules.index(r)][1]
 		text1="{"+head+"} :- "+bl+".\n"
 		if "(" in head:
			variables=re.findall(r"([A-Z]+[0-9]*)",head[head.find("(")::])
		else:
			variables=[]
		abchead="ab_activated("+r
		weakvar=""
		#Jan 9 - if either no entry is given or the rule is desired to be activated
		if activatingrules==0 or r in activatingrules:
			if "#show ab_activated/"+str(len(variables)+1)+"." not in showatoms:
				showatoms.append("#show ab_activated/"+str(len(variables)+1)+".")
			for var in variables:
				abchead=abchead+","+var
				weakvar+=","+var
			weakcons=":~ "+abchead+"). "+"[1"+weakvar+","+r+"]\n"
		#Jan 9 - if there is an entry and rule is not desired to be activated then no further ab atoms are added for this rule
		else:
			#weakcons=":~ "+abchead+"). "+"[10"+weakvar+","+r+"]\n"
			continue
		abchead=abchead+") :- "
		text2=abchead+bl+", "+head+".\n"
		print text1+text2+weakcons
		outtext=outtext+text1+text2+weakcons
		
	'''
	refinehinttext=""
	collectrefinecountrules=[]
	for p in m.predList:
		if activatingpreds!=0 and p not in activatingpreds and p.replace("choice_","") not in activatingpreds:
			continue
		#if "choice" in p or 
		# Feb 5'19 - if choice version of the atom was processed before dont process it again
		if "{" in p or "choiceplaceholder" in p or "choice_"+p in m.predList[:m.predList.index(p)]:# or "conn" in p:
			continue
		syms=m.getPredSym(p)
		# Feb 5'19 - get all atoms involved in the choice head
		if "choice_" in p:
			syms+=m.getPredSym(p.replace("choice_",""))
		syms=[sym for sym in syms if "h" in sym]
		#print syms
		#print p
		#symsvar=[sym for sym in syms if m.getType(sym)=="var"]
		#symsconst=[sym for sym in syms if m.getType(sym)=="const"]
		text1head=""
		bodya1=[]	
		#for sym in symsvar:
		weakvar=""
		fact=[]
		createdRulesForEachSym=False
		for sym in syms:
			if "const" in m.getType(sym):
				rulename=re.findall(r"(r\d+)h",sym)[0]
				if m.getPosbody(rulename)==[] and m.getNegbody(rulename)==[]:
					fact.append("fact("+m.getAtom(sym)[0]+").\n")
					continue
				#if text1head=="":
				#FIXME hepsinin head i ayni sekilde assume 
				#       Feb 15'19 - when the head contains a constant, this assumption does not hol
				#                    now if there is a constant, if creates abc rules for each 
				#                   ASSUMING that there only one rule with the head
				head=m.getAtom(sym)[0]	
				if "{" in head: 
					head=head.replace("{","")    
					head=head.replace("}","")    
				#if "equ" in head or "less" in head:
				#	break
				text1head="{"+head+"} :- "
				if head.find("(")!=-1:
					bl="bl("+rulename+","+head[head.find("(")+1:head.find(")")]+")"
					weakvar=","+head[head.find("(")+1:head.find(")")]
				else:
					#bl="bl("+rulename+")"
					bl=m.blAtoms[m.rules.index(rulename)][1]
				bodya1.append(bl)
				if bodya1!=[]:
					text1body=",".join(bodya1)+".\n"	
					#print text1head+text1body
					outtext=outtext+text1head+text1body
					text3="ab_activated("+head+") :- "+",".join(bodya1)+", "+head
					if fact!=[]:
						text3+=", not fact("+head+").\n"+"".join(fact)
					else:
						text3+=".\n"
					#print text3
					if activatingpreds==0:
						text4=":~ ab_activated("+head+"). "+"[1"+weakvar+"]\n"
					else:
						text4=":~ ab_activated("+head+"). "+"[1"+weakvar+"]\n"
					#refinehinttext+=createRefineHintRule("ab_activated("+head+")",collectrefinecountrules)
					#avoidsingletontext=createAvoidSingletonRule("ab_activated("+head+")",collectrefinecountrules)
					#if avoidsingletontext!="":
						#text4+=":~ ab_activated("+head+"), "+avoidsingletontext+". [20"+weakvar+"]\n"
					outtext=outtext+text3+text4  
				createdRulesForEachSym=True
				bodya1=[]
			else:	
				rulename=re.findall(r"(r\d+)h",sym)[0]
				if m.getPosbody(rulename)==[] and m.getNegbody(rulename)==[]:
					fact.append("fact("+m.getAtom(sym)[0]+").\n")
					continue
				if text1head=="":
					#FIXME hepsinin head i ayni sekilde assume
					head=m.getAtom(sym)[0]	
					if "{" in head: 
						head=head.replace("{","")    
						head=head.replace("}","")   
					#if "equ" in head or "less" in head:
					#	break
					text1head="{"+head+"} :- "
				if head.find("(")!=-1:
					bl="bl("+rulename+","+head[head.find("(")+1:head.find(")")]+")"
					weakvar=","+head[head.find("(")+1:head.find(")")]
				else:
					bl="bl("+rulename+")"
				#bl=m.blAtoms[m.rules.index(rulename)][1]
				bodya1.append(bl)
		if createdRulesForEachSym==False:
			if bodya1!=[]:
				text1body=",".join(bodya1)+".\n"	
				#print text1head+text1body
				outtext=outtext+text1head+text1body
				text3="ab_activated("+head+") :- "+",".join(bodya1)+", "+head
				if fact!=[]:
					text3+=", not fact("+head+").\n"+"".join(fact)
				else:
					text3+=".\n"
				#print text3
				if activatingpreds==0:
					text4=":~ ab_activated("+head+"). "+"[1"+weakvar+"]\n"
				else:
					text4=":~ ab_activated("+head+"). "+"[1"+weakvar+"]\n"
				#refinehinttext+=createRefineHintRule("ab_activated("+head+")",collectrefinecountrules)
				#avoidsingletontext=createAvoidSingletonRule("ab_activated("+head+")",collectrefinecountrules)
				#if avoidsingletontext!="":
					#text4+=":~ ab_activated("+head+"), "+avoidsingletontext+". [20"+weakvar+"]\n"
				outtext=outtext+text3+text4    
		'''bodya=[]
		for sym in symsconst:
			head=m.getAtom(sym)[0]	
			text2head="{"+head+"} :- "
			rulename=re.findall(r"(r\d+)h",sym)[0]
			bl=m.blAtoms[m.rules.index(rulename)][1]
			bodya.append(bl)
			text2body=",".join(bodya)+".\n"	
			print text2head+text2body
			outtext=outtext+text2head+text2body
			text3="ab_c("+head+") :- "+",".join(bodya)+", "+head+".\n"
			print text3
			outtext=outtext+text3
			bodya=[]
			#print text2'''
	#return outtext+"\n".join(showatoms)+"\n"
	
	#if collectrefinecountrules!=[]:
		#textrefinecount="\nrefineCountAbC(AA,S) :- refine(AA), S=#count{"+" ; ".join(collectrefinecountrules)+"}.\n#show refineCountAbC/2.\n"
	#else:
	textrefinecount=""
	return outtext+"#show ab_activated/1.\n"#+refinehinttext+"#show refine/2."+textrefinecount

#def postProcessCellElts(text):
    #cells=re.findall(r"x(\d+)y(\d+)",text)
    #for a in cells:
        #text=text.replace("x"+a[0]+"y"+a[1],"("+a[0]+","+a[1]+")")
    #return text

#input needs to be the MetaTranslator output of the program
fileorg=sys.argv[1]


if "objname" in fileorg:
    obj=True
    objname="cell"
else:
    obj=False



if len(sys.argv) ==3:
    if re.findall(r"r(\d+)",sys.argv[2]):
        deactivatingrules=sys.argv[2]
        deactivatingrules=deactivatingrules.split(",")
        activatingpreds=0    
    else:
        deactivatingrules=0 
        activatingpreds=sys.argv[2]
        activatingpreds=activatingpreds.split(",")
elif len(sys.argv) ==4:
    deactivatingrules=sys.argv[2]
    activatingpreds=sys.argv[3]
    deactivatingrules=deactivatingrules.split(",")
    activatingpreds=activatingpreds.split(",")    
else:
    deactivatingrules=0
    activatingpreds=0

fin=open(fileorg,"r")
textOrg=fin.read()
fin.close()

m=meta(textOrg)
m.initializeAtoms()
#m.printout()


outtext=""

outtext=buildMainRules(m,outtext)
outtext=outtext+"\n\n"

#outtext=postProcessCellElts(outtext)

fout=open(fileorg+"_debug_onlymain","w")
fout.write(outtext)
fout.close()

if deactivatingrules==0 and activatingpreds==0:
    outtext=buildAbPRules(m,outtext,deactivatingrules)
    outtext=outtext+"\n\n"
    outtext=buildAbCRules(m,outtext,activatingpreds)
    #outtext+="\nrefineCountMain(AA,S+S1,N) :-  refineCountAbC(AA,S), refineCountAbP(AA,S1), N=#count{X: mapTo(_,X,AA)}.\n#show refineCountMain/3.\n"
elif deactivatingrules!=0:
    outtext=buildAbPRules(m,outtext,deactivatingrules)
    outtext=outtext+"\n\n"
    if activatingpreds!=0:
        outtext=buildAbCRules(m,outtext,activatingpreds)
    	#outtext+="\nrefineCountMain(AA,BB,S+S1) :-  refineCountAbC(AA,BB,S), refineCountAbP(AA,BB,S1).\n#show refineCountMain/3.\n"
    	#outtext+="\nrefineCountMain(AA,S+S1,N) :-  refineCountAbC(AA,S), refineCountAbP(AA,S1), N=#count{X: mapTo(_,X,AA)}.\n#show refineCountMain/3.\n"
    # Feb 4'19 if we give what rules to deactivate but no preds, then no abc rules will be created! 
    #           Let's see if it will be ok    
    #else:
        ##outtext+="\nrefineCountMain(AA,BB,S1) :-  refineCountAbP(AA,BB,S1).\n#show refineCountMain/3.\n"
        #outtext+="\nrefineCountMain(AA,S1,N) :-  refineCountAbP(AA,S1), N=#count{X: mapTo(_,X,AA)}.\n#show refineCountMain/3.\n"
else:
    outtext=buildAbPRules(m,outtext,[])
    outtext=outtext+"\n\n"
    outtext=buildAbCRules(m,outtext,activatingpreds)
    #outtext+="\nrefineCountMain(AA,BB,S+S1) :-  refineCountAbC(AA,BB,S), refineCountAbP(AA,BB,S1).\n#show refineCountMain/3.\n"
    #outtext+="\nrefineCountMain(AA,BB,S,N) :-  refineCountAbC(AA,BB,S), N=#count{X,Y: mapTo(_,X,Y,AA,BB)}.\n#show refineCountMain/4.\n"
    #outtext+="\nrefineCountMain(AA,S+S1,N) :-  refineCountAbC(AA,S), refineCountAbP(AA,S1), N=#count{X: mapTo(_,X,AA)}.\n#show refineCountMain/3.\n"
fout=open(fileorg+"_debug","w")
fout.write(outtext)
fout.close()
